﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.9
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Type myDataType(mssid() As Byte, mpass() As Byte)
	Public myData As myDataType
End Sub

Public Sub StartStaBroker(mySSID() As Byte,myPASS() As Byte)	
	myData.mssid = mySSID
	myData.mpass = myPASS
	RunNative("StartStaBroker",myData)
End Sub


#if C
#include <ESP8266WiFi.h>
#include "uMQTTBroker.h"
//#include "user_interface.h"
void data_callback(uint32_t *client /* we can ignore this */, const char* topic, uint32_t topic_len, const char *data, uint32_t lengh) {
  char topic_str[topic_len+1];
  os_memcpy(topic_str, topic, topic_len);
  topic_str[topic_len] = '\0';

  char data_str[lengh+1];
  os_memcpy(data_str, data, lengh);
  data_str[lengh] = '\0';

  Serial.print("received topic '");
  Serial.print(topic_str);
  Serial.print("' with data '");
  Serial.print(data_str);
  Serial.println("'");
}

void StartStaBroker (B4R::Object* o) {
	
	_mydatatype* tmp = (_mydatatype*)B4R::Object::toPointer(o);//get array from sub StartStaBroker
	
	B4R::Array* b = tmp->mssid;//get array ssid from main
	char* tssid = (char*)b->data;//get ssid	
	
	B4R::Array* z = tmp->mpass;//get array pass from main
	char* tpass = (char*)z->data;//get pass	
	
    const char* ssid = tssid;
    const char* password = tpass;

	unsigned int mqttPort = 1883;       // the standard MQTT broker port
	unsigned int max_subscriptions = 30;
	unsigned int max_retained_topics = 30;

	WiFi.begin(ssid, password);
	Serial.print("Connecting to ");
    Serial.print(ssid); Serial.println(" ...");
	
	int i = 0;
    while (WiFi.status() != WL_CONNECTED) { // Wait for the Wi-Fi to connect
    delay(1000);
    Serial.print(++i); Serial.print(' ');
  }
    Serial.println('\n');
	Serial.println("Connection established!");  
    Serial.print("IP address:\t");
    Serial.println(WiFi.localIP());
	
	Serial.println("Starting MQTT broker");	
	MQTT_server_onData(data_callback);		    
    MQTT_server_start(mqttPort, max_subscriptions, max_retained_topics);// <--- Start Broker
	MQTT_local_subscribe((unsigned char *)"#", 0);
	
	//int counter = 0;
	//String myData(counter++);	
	//MQTT_local_publish((unsigned char *)"/MyBroker/count", (unsigned char *)myData.c_str(), myData.length(), 0, 0);	
	//for(int o = 0; o< 50; o++){
    //Do something
    //String myData(counter++);
    //MQTT_local_publish((unsigned char *)"/MyBroker/count", (unsigned char *)myData.c_str(), myData.length(), 0, 0);
	//}
			
}

#End If